var express = require("express");
var bodyParser = require("body-parser");

var app = express();
app.use(bodyParser.json());
app.use(bodyParser.text());
app.use(bodyParser.urlencoded({extended: true}));
app.use(express.static('./demo/static'));

app.all('*', function(req, res, next){
        res.header("Access-Control-Allow-Origin", "*");
        res.header("Access-Control-Allow-Headers", "X-Requested-With");
        res.header("Access-Control-Allow-Methods", "GET,POST,OPTIONS");
        next();
});


app.post("/gt/verify", function (req, res) {
    var sense = require('./sense')
    // 对ajax提供的验证凭证进行二次验证
    sense.verify({
        challenge: req.body.challenge,
        idType: 1,
        idValue: req.body.phone
    }, function (err, success) {        
        if (err) {

            // 网络错误
            res.send({
                status: "error",
                info: err
            });

        } else if (!success || success.status === 'error') {
            console.log(success)
            // 二次验证失败
            res.send({
                status: "fail",
                info: '登录失败'
            });
        } else {
            console.log(success)
            //
            res.send({
                status: "success",
                info: '登录成功'
            });
        }
    });
});

var port = 9977;
app.listen(port, function () {
    console.log('listening at http://localhost:' + port)
});
